<?php
/*
 * Пример работы с API
 * рассылка счетов на оплату клиентам  
 */

// Инициализируем класс для работы с api
require_once('flexbe_api.class.php');
$api_url = 'http://lp12345.myflexbe.com/mod/api/';
$api_key = 'ed677c52dccc04a456f846ebe06849b1';

$flexbe = new flexbeAPI($api_url,$api_key);

// Проверка подключения
if ( !$flexbe->checkConnection() ) {
	print_r($flexbe->errors); 
	exit();
}

// Получаем 5 заявок со статусом новая
// не старше 1го месяца, и не сегодняшние
$query_result = $flexbe->getLeads(array(
	'status' => 0, // 0- новая, см. $leads_statuses
	'start' => 0, 'count' => 5, // с 0 по 5ую

	// Дата создания заявки больше чем месяц назад
	'date_from'=>strtotime('-1 month'),
	// но меньше сегодня
	'date_to'=>strtotime('today UTC'),

	// Фильтр по номеру телефона клиента
	// 'client_phone'=>'89112223344',
	// Фильтр по email адресу клиента
	// 'client_email'=>'dev@flexbe.com',
));
$leads = $query_result['data']['leads'];


foreach ($leads as $lead_id => $lead) {
	/* 	
		Чтобы не превышать лимит запросов в минуту
		если у нас много заявок и запросы отправляются вот так в цикле один за другим
		делаем паузу 
	*/
	if (count($leads) > 30) {
		sleep(1);
	}


	// Массив новой информации для заявки 
	$fields = array(); 


	// Установим статус "в работе"
	// если заявка новая
	if ($lead['status']['code']==0) {
		$fields['status'] = 1; // Статус 1 - "В работе" см. $leads_statuses
	}

	// Добавим в заметки запись отредактировано
	$fields['note'] = '[[ Отредактировано через API '.date('d.m.Y H:i').' ]] '.$lead['note'];

	// Можно изменить информацию о контакте
	/* $fields['client'] = array(
		'name'=>'Имя контакта',
		'phone'=>'89112223344',
		'email'=>'dev@flexbe.com',
	);*/

	// Добавим счёт на оплату
	// если его нет
	if (!is_array($lead['pay'])) {
		$fields['pay'] = array(
			'summ'=>'99.99', 	// сумма счёта
			'status'=>0, 		// см. $pays_statuses
			'desc'=>'Комментрий к счёту для пользователя',
		);
	}

	// Вызываем метод изменения заявки
	$result = $flexbe->changeLead($lead['id'], $fields);

	// Если всё ок
	if ($result['status']==1) {
		// Отправим email-уведомление клиенту
		// с ссылкой на оплату счёта
		if (!empty($result['data']['pay']['pay_link']) && !empty($lead['client']['email'])) {
			$topic = 'Вам выставлен счёт на оплату';
			if (!empty($lead['client']['name'])) {
				$topic = $lead['client']['name'].', '.$topic;
			}
			
			$message = 'Для просмотра счёта перейдите по ссылке: <br>
			<a href="'.$result['data']['pay']['pay_link'].'">'.$result['data']['pay']['pay_link'].'</a>';
			
			mail($lead['client']['email'], $topic, $message);
		}
	}

} // foreach ($leads ...